#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two19004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 1900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two19004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two19004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 1900
# -------------------------------------------------------------------------------------------------
shot2two19004xi = {
        1:'1062x-1574y-36z',
        2:'1079x-1540y-267z',
        3:'1142x-1516y-55z',
        4:'1157x-1479y-285z',
        5:'115x-783y-1727z',
        6:'1220x-1454y-74z',
        7:'1231x-1414y-304z',
        8:'127x-987y-1618z',
        9:'1294x-1387y-93z',
        10:'1301x-1346y-323z',
        11:'1364x-1317y-112z',
        12:'1367x-1273y-342z',
        13:'136x-1228y-1443z',
        14:'1429x-1198y-360z',
        15:'1430x-1243y-131z',
        16:'1487x-1119y-379z',
        17:'1492x-1166y-150z',
        18:'152x-759y-1735z',
        19:'1540x-1038y-398z',
        20:'1550x-1085y-169z',
        21:'1589x-953y-416z',
        22:'1603x-1001y-188z',
        23:'1633x-867y-435z',
        24:'1651x-915y-207z',
        25:'166x-1891y-77z',
        26:'1672x-778y-453z',
        27:'1695x-826y-226z',
        28:'1706x-688y-471z',
        29:'1734x-736y-245z',
        30:'1735x-596y-490z',
        31:'1759x-503y-508z',
        32:'175x-963y-1628z',
        33:'1768x-643y-263z',
        34:'1778x-409y-526z',
        35:'1792x-315y-545z',
        36:'1796x-549y-282z',
        37:'1801x-220y-563z',
        38:'1802x-30y-599z',
        39:'1804x-125y-581z',
        40:'1820x-453y-301z',
        41:'1835x-491y-5z',
        42:'1838x-357y-320z',
        43:'1851x-260y-338z',
        44:'1858x-162y-357z',
        45:'1858x-394y-24z',
        46:'1861x-64y-376z',
        47:'1876x-297y-43z',
        48:'187x-733y-1742z',
        49:'1888x-198y-62z',
        50:'1895x-99y-81z',
        51:'197x-1204y-1455z',
        52:'222x-936y-1637z',
        53:'232x-742y-1842z',
        54:'24x-1027y-1598z',
        55:'257x-1178y-1467z',
        56:'265x-1878y-96z',
        57:'266x-908y-1647z',
        58:'307x-877y-1656z',
        59:'315x-1149y-1479z',
        60:'347x-844y-1666z',
        61:'34x-825y-1711z',
        62:'362x-1861y-115z',
        63:'370x-1117y-1491z',
        64:'383x-810y-1675z',
        65:'417x-774y-1684z',
        66:'422x-1082y-1503z',
        67:'448x-736y-1692z',
        68:'459x-1838y-134z',
        69:'472x-1044y-1514z',
        70:'477x-698y-1701z',
        71:'502x-658y-1709z',
        72:'519x-1005y-1526z',
        73:'525x-618y-1717z',
        74:'527x-15y-1825z',
        75:'544x-44y-1819z',
        76:'545x-577y-1725z',
        77:'554x-1810y-153z',
        78:'559x-75y-1814z',
        79:'562x-536y-1733z',
        80:'563x-963y-1537z',
        81:'572x-107y-1808z',
        82:'576x-495y-1741z',
        83:'583x-141y-1802z',
        84:'587x-453y-1748z',
        85:'592x-177y-1796z',
        86:'596x-412y-1756z',
        87:'599x-214y-1790z',
        88:'601x-371y-1763z',
        89:'603x-251y-1783z',
        90:'604x-919y-1548z',
        91:'605x-290y-1777z',
        92:'605x-330y-1770z',
        93:'642x-874y-1559z',
        94:'648x-1777y-172z',
        95:'677x-827y-1570z',
        96:'67x-1897y-58z',
        97:'709x-779y-1580z',
        98:'72x-1247y-1430z',
        99:'738x-729y-1591z',
        100:'739x-1739y-191z',
        101:'75x-805y-1719z',
        102:'763x-679y-1601z',
        103:'76x-1008y-1608z',
        104:'785x-628y-1611z',
        105:'7x-1264y-1418z',
        106:'804x-37y-1720z',
        107:'804x-577y-1621z',
        108:'818x-81y-1712z',
        109:'819x-525y-1631z',
        110:'828x-1696y-210z',
        111:'830x-126y-1704z',
        112:'831x-473y-1641z',
        113:'839x-173y-1695z',
        114:'840x-422y-1650z',
        115:'845x-221y-1687z',
        116:'846x-371y-1660z',
        117:'848x-270y-1678z',
        118:'849x-320y-1669z',
        119:'915x-1649y-229z',
        120:'978x-1628y-17z',
        121:'999x-1596y-248z'}
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1900two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1900two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1900TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1900TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1900TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1900TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1900TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two19004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1900TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1900TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1900TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two19004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two19004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1900TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1900TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1900TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two19004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        